###############################################
# FILE: lines_format.pat
# SUBJ: Make lines inside text zones.
# AUTH: AM
# CREATED: 20/Jun/02 15:59:10
# NOTE:	To handle formats like HTML.  Would be
#	nice to merge with the Lines pass. (If context can
#	be parameterized.
###############################################

@CODE
if (!G("zoning")
 || G("plain text")	# Not an sgml doc, etc.	# 07/14/02 AM.
 || G("messy"))	# 03/20/02 AM.
	exitpass();
@@CODE

# Todo: Would be nice to parameterize the context criteria, eg,
# with a global variable.	# 07/14/02 AM.
@NODES _TEXTZONE

@RULES

_BLANKLINE <-
    _xWILD [min=0 max=0 matches=(\ \t \r)] ### (1)
    \n ### (2)
    @@

_RULELINE <-
	_xWHITE [s star]
	_xPUNCT [min=2 max=0]
    _xWILD [min=0 max=0 matches=(\ \t \r)]
    \n
	@@

@RULES
_LINE [unsealed] <-
    _xWILD [min=0 max=0 fails=(\r \n
		_TEXTZONE _LINE _RULELINE _BLANKLINE)] ### (1)
    \n ### (2)
    @@

_LINE [unsealed] <-
    _xWILD [min=0 max=0 fails=(\r \n
		_TEXTZONE _LINE _RULELINE _BLANKLINE)] ### (1)
    _xWILD [opt match=(_xEND)] ### (2)
    @@
