###############################################
# FILE: seg10.pat
# SUBJ: Segment or "chunk" text.
# AUTH: AM
# CREATED: 24/Feb/02 23:56:33
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

# Sentinels
@POST
  noop();
@RULES
_xNIL <- _xWILD [s one match=(
	_np _vg _pp _seg
	)] @@
###

@POST
  pncopyvars(1);
  single();
@RULES
_np <-
	_xWILD [s one match=(_pro) except=(_proPoss _np)]
	@@

@POST
  singler(2,3);
@RULES
_np <-
	_xWILD [s one match=(_prep)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s plus match=(_xNUM _num _quan)]
	_xWILD [s one lookahead match=(_qEOS)]
	@@

@CHECK
  if (!N("adv",2))
    fail();
@POST
  group(2,2,"_adv");
@RULES
_xNIL <-
	_xWILD [s one lookahead match=(_prep)]
	_xALPHA
	_xWILD [s one match=(_xNUM _num _quan)]
	@@

@POST
  group(1,1,"_np");
@RULES
_xNIL <-
	_xWILD [s one match=(this these those) except=(_np _nps)]
	_vg [s lookahead]
	@@

# This rule is too sloppy.
@POST
  S("seg type") = "np";
  if (N("$text",4) == "_qEOS")
    S("eos") = 1;
  S("tmp") = lasteltnode(3);
  if (pnname(S("tmp")) == "_noun")
    pncopyvars(S("tmp"));
  singler(1,3);
@RULES
_seg <-
	_xWILD [s one match=(_det _quan _num _xNUM _noun _proPoss
		_premod)
		except=(_np _nps _fnword)]
	_xWILD [s star match=(_adv _advl)] # 03/16/02 AM.
	_xWILD [plus match=(_xALPHA _noun _adj _xNUM _num _quan
		_acro	# 05/02/02 AM.
#		_verb	# 05/02/02 AM.
		_retok	# 09/05/02 AM.
		_aposS)]
	_xWILD [s one lookahead match=(
		_seg
		_modal _have _be _vg
		_verb	# Trying this.	# 05/02/02 AM.
		_advl _adv
		_prep
		_conj
		_xPUNCT
		_fnword
		_pro _np
		_det # 03/16/02 AM.
		_dbldash _qEOS
		)]
	@@
# At end of text.
@POST
  S("seg type") = "np";
  S("eos") = 1;
  singler(1,3);
@RULES
_seg <-
	_xWILD [s one match=(_det _quan _num _xNUM _noun _proPoss
		_premod)
		except=(_np _nps _fnword)]
	_xWILD [s star match=(_adv _advl)] # 03/16/02 AM.
	_xWILD [plus match=(_xALPHA _noun _adj _xNUM _num _quan
		_acro	# 05/02/02 AM.
		_retok	# 09/05/02 AM.
		_aposS)]
	_xEND
	@@

#@POST
#  S("seg type") = "vg";
#  singler(1,2);
#@RULES
#_seg <-
#   _xWILD [s one match=(_modal _have _be)]
#   _xWILD [s opt fail=(_seg _np _vg)]
#   _xWILD [s one lookahead match=(
#	 _det _quan _num _xNUM
#	 _adj
#	 _advl _adv
#	 _prep
#	 _conj
#	 _xPUNCT
#	 _fnword
#	 _pro
#	 )]
#	@@

@POST
  pncopyvars();
  single();
@RULES
_np <- _name [s] @@

# Otherwise, collect a blob of nodes.
# Doing this for glommed sentence.
# 05/01/02 AM.
@POST
  S("seg type") = "alpha";
  G("tmp") = lasteltnode(1);
  pncopyvars(G("tmp"));
  if (G("tmp1") = pnnext(G("tmp")))
    {
	if (pnname(G("tmp1")) == "_qEOS")
	  S("eos") = 1;
	}
  else
    S("eos") = 1;
  single();
@RULES
_seg <-
	_xWILD [s min=2 fail=(
		_det
#		_quan _num _xNUM
		_vg _modal _have _be
		_verb	# Trying this.	# 05/02/02 AM.
		_prep _premod
		_conj
		_xPUNCT
		_fnword
		_pro
		_whtSEP _whtINDENT
		_dbldash
		_np _seg
		_adv _advl
		_sentence
		)
		except=(_acro)
		]
	@@

@POST
  S("seg type") = "alpha";
  # Get the head of the phrase.
  G("tmp") = lasteltnode(2);
  G("nm") = pnname(G("tmp"));
  pncopyvars(G("tmp")); # Copy to suggested node.
  if (pnvar(G("tmp"),"pos num") == 1)	# Unambiguous
    {
	if (G("nm") == "_adj")
		S("seg type") = "adj";
	else if (G("nm") == "_adjs")
		S("seg type") = "adjs";
	else if (G("nm") == "_noun")
		S("seg type") = "np";
	}
  single();
@RULES
_seg <-
  _xWILD [s opt match=(_proPoss this these those)]
  _xWILD [s min=2
  	match=(
  		_adj _adjs _noun _aposS
#		_verb	# 05/02/02 AM.
		_xALPHA
  		)
	except=(_seg _np _vg _modal _have _be
		_verb	# 05/02/02 AM.
		_det _quan _num _xNUM
		_prep _conj _fnword
		_adv _advl _pro
	)]
	@@

@POST
  pncopyvars(2);
  single();
@RULES
_np <-
  _xWILD [s one match=(_proPoss this these those)]
  _noun
  @@

# Need better seg collection here....
@CHECK
  if (!N("noun",2))
    fail();
  if (N("number",1))
    {
	S("num2") = number(N(2));
	if (S("num2") != "any"
	 && S("num2") != N("number",1))
	   fail();
	}
@POST
  pncopyvars(2);
  single();
@RULES
_np <-
	_xWILD [s one match=(_proPoss this these those)]
	_xALPHA
	@@


# Convert lone noun to np seg, etc.
#@POST
#  S("seg type") = "np";
#  single();
#@RULES
#_seg <- _noun [s] @@

# Note sure why the above was commented out.
# But putting in some specific stuff.
@POST
  pncopyvars(2);
  singler(2,2);
@RULES
_np <-
	_xWILD [one match=(_conj)]
	_xWILD [one match=(_noun)]
	_xWILD [one lookahead match=(_xPUNCT)]
	@@

@POST
  S("seg type") = "vg";
  pncopyvars();
  single();
@RULES
_seg <- _verb [s] @@

@POST
  S("num2") = number(N(2));
  if (N("noun",2)
   && S("num2") == "plural" )
	group(2,2,"_noun");
@RULES
_xNIL <-
  _xWILD [s one match=(_qEOS)]
  _xALPHA
  _xWILD [s one lookahead match=(_conj)]
  @@

# If it's a lone alpha, convert to alpha seg.
@POST
  S("seg type") = "alpha";
  pncopyvars();
  single();
@RULES
_seg <- _xALPHA @@

@RULES
_np <-
	_xWILD [s one match=(all most some few each)]
	of [s]
	_np
	@@

@POST
  group(2,2,"_np");
@RULES
_xNIL <-
	_prep [s]
	_xNUM
	_xWILD [s one lookahead match=(_qEOS)]
	@@

@CHECK
  S("text") = strtolower(N("$text",2));
  if (strendswith(S("text"),"ing")
   || strendswith(S("text"),"ed")
   || N("-edn", 2)
   || suffix(S("text"),"s") )
    fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_vg");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	to [s]
	_verb
	@@

# to pump green slime
@CHECK
	if (!N("verb",2))
		fail();
	if (!N("adj",3) && !N("noun",3))
		fail();
	S("text") = strtolower(N("$text",2));
	if (suffix(S("text"),"s") ||
		suffix(S("text"),"ing") ||
		suffix(S("text"),"ed") ||
		N("-edn",2) )
		fail();
@POST
  group(2,2,"_verb");
  group(2,2,"_vg");
@RULES
_xNIL <-
	to [s]
	_xALPHA
	_xALPHA [lookahead]
	@@

@CHECK
	if (!N("verb",2))
		fail();
	S("text") = strtolower(N("$text",2));
	if (suffix(S("text"),"s") ||
		suffix(S("text"),"ing") ||
		suffix(S("text"),"ed") ||
		N("-edn",2) )
		fail();
@POST
  group(2,2,"_verb");
  group(2,2,"_vg");
@RULES
_xNIL <-
	to [s]
	_xALPHA
	_xWILD [one lookahead match=(
		_det _quan _xNUM _num _adj _adjs _np _prep)]
	@@

#Headless, numeric noun phrase.
@POST
  pncopyvars(1);
  S("numeric np") = 1;
  single();
@RULES
_np <-
	_xWILD [one match=(_quan _num _xNUM)]
	@@

