###############################################
# FILE: seg250.pat
# SUBJ: Resolve seg by clause snippets (after pp finding).
# AUTH: AM
# CREATED: 19/May/02 09:36:38
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

@POST
  if (N("seg nouns",4))
    pnrename(N(4),"_np");
@RULES
_xNIL <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	\, [s opt]
	_seg
	_xWILD [s star lookahead match=(_adv _advl)]
	_vg
	@@

@CHECK
  if (!N("seg last verb",2))
    fail();
@POST
  pnrename(N(2),"_seg");	# In case it's named _np.
  N("seg split last verb",2) = 1;
@RULES
_xNIL <-
	_xWILD [one match=(_fnword)]
	_xWILD [one match=(_seg _np)]
	_xWILD [s one match=(_fnword _np)]
	@@

# adj to verb and seg to verb
@CHECK
# Should at least be a verb -en...
  if (N("adj",5))
    succeed();
  if (!N("verb",5))
    fail();
  S("tmp") = vconj(N(5));
  if (S("tmp") != "-edn"
   && S("tmp") != "-en")
    fail();
@POST
  N("id",5) = "seg250 10";
  pnrename(N(5),"_adj");
  # Fix up grammar here...
  group(7,7,"_clause");
  group(6,7,"_advl");
  N("pattern",6) = "to-inf";
  group(3,3,"_clause");
  group(2,3,"_advl");
  N("pattern",2) = "to-inf";
@RULES
_xNIL <-
	_adj [s]
	to [s]
	_vg
	_conj [s]
	_seg
	to [s]
	_vg
	@@
