###############################################
# FILE: zone21.pat
# SUBJ: comment here
# AUTH: AM
# CREATED: 21/Apr/02 23:23:59
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT

@CHECK
  if ((N("avg length") + 6.0) >= G("maxzone avg length"))
    succeed();
  # Place other criteria for a text zone here.
  
  # If avg length is reasonable, then look at other stuff...
  if ((N("avg length") + 10.0) >= G("maxzone avg length"))
    {
	# 2*n+2 is max sloppy ends and starts.  Require less.
	if (N("nlines"))
	  N("ratio") = ( flt(N("sloppy start") + N("sloppy end"))
		/ flt(N("nlines")) );
	else
	  N("ratio") = 0;
	if (N("ratio") >= 0.50)
	  succeed();
	if (N("ratio") >= 0.25 && N("widow")
	 && N("nlines") > 2 )
	  succeed();
	}

  fail();
@POST
  pnrename(N(1),"_TEXTZONE");
@RULES
_xNIL <-
	_zone
	@@
