###############################################
# FILE: format_ck.pat
# SUBJ: Check for various file formats.
# AUTH: AM
# CREATED: 13/Jun/02 17:14:48
# MODIFIED:
###############################################

@CODE
G("html") = 0;
G("xml") = 0;
G("tags") = 0;	# Count simple markup tags.
G("last is tag") = 0;	# If last thing in text is a tag.
@@CODE

@NODES _ROOT

@POST
  ++G("xml");
  ++G("tags");
  G("plain text") = 0;	# SET DOC FORMAT. # 07/14/02 AM.
@RULES
_xNIL <-
	_xSTART
	_xWHITE [s star]
	\<
	\?
	xml
	@@

@POST
  ++G("html");
  ++G("tags");
  G("plain text") = 0;	# SET DOC FORMAT. # 07/14/02 AM.
@RULES
_xNIL <-
	_xSTART
	_xWHITE [s star]
	\<
	html
	@@

@POST
  ++G("tags");
  G("last is tag") = 1;
  G("plain text") = 0;	# SET DOC FORMAT. # 07/14/02 AM.
@RULES
_xNIL <-
	\<
	\/
	_xWILD [min=1 max=30]
	\>
	@@

@POST
  ++G("tags");
  G("last is tag") = 1;
  G("plain text") = 0;	# SET DOC FORMAT. # 07/14/02 AM.
@RULES
_xNIL <-
	\<
	_xWILD [min=1 max=30]
	\>
	@@

@POST
  G("last is tag") = 0;
@RULES
_xNIL <-
	_xWILD [plus fail=(_xWHITE \< )]	# Match anything but whitespace and start of tag.
	@@
