###############################################
# FILE: l_retok100.pat
# SUBJ: Some precedence in retokenizing.
# AUTH: AM
# CREATED: 17/May/02 23:33:12
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@NODES _LINE

# Misc mumbles
# More generally, should collect big tokens into "segments",
# then look in these to decide what they are.
@RULES
_mumble <-
	_xWILD [s min=3 match=(_xALPHA _xNUM)]
	@@

@RULES
_adj <-
	_xALPHA
	\- [s opt]
	_xNUM
	\- [s]
	_xWILD [s one match=(type like)]
	@@

_conj <-
	and [s]
	\/ [s]
	or [s]
	@@

_noun <-
	_xALPHA
	\- [s opt]
	_xNUM
	@@

# Dumb rules, to avoid recursion...
@RULES
_abbrev [layer=(_noun _np)] <-
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	@@
_abbrev [layer=(_noun _np)] <-
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	@@
_abbrev [layer=(_noun _np)] <-
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	@@
_abbrev [layer=(_noun _np)] <-
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	@@
_abbrev [layer=(_noun _np)] <-
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWHITE [s star]
	_xALPHA
	\. [s]
	_xWILD [s star match=(_xALPHA \.)]
	@@

