###############################################
# FILE: line_xseg.pat
# SUBJ: Dissolve line-oriented segmentation.
# AUTH: AM
# CREATED: 22/Apr/02 11:52:29
# NOTE:	To allow more seamless integration of constructs that
#	cross line boundaries, undo reductions at start and end
#	of each line.
#	05/02/02 AM. In general, might need to undo everything that
#	was done line-oriented.
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _LINE

# Zapping line-oriented components built.
@CHECK
  if (N("don't splice"))
    fail();
@POST
  splice(1,1);
@RULES
_xNIL <-
	_xWILD [one match=(_seg _vg _np)]
	@@
