###############################################
# FILE: postsent.pat
# SUBJ: Processing after breaking into sentences.
# AUTH: AM
# CREATED: 28/May/02 10:28:52
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

# Break up protected scopes, such as parentheticals, so that
# they may be subject to parsing and other processing.
@POST
  splice(1,1);
@RULES
_xNIL <-
	_scope
	@@

# Flag question/query/interrogative forms.
@POST
  X("question") = 1;
@RULES
_xNIL <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_whword [s]
	@@

# Flag imperative.
@CHECK
  if (vconj(N(3)) != "inf")
  	fail();
@POST
  X("imperative") = 1;
@RULES
_xNIL <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_verb _vg)]
	@@
