###############################################
# FILE: qzone.pat
# SUBJ: Characterize zone based on lines in it.
# AUTH: AM
# CREATED: 01/Dec/01 08:57:13
# NOTE:	01/30/02 AM. Renamed from dom_qlines.
#	Count lines in a zone, gather other data from lines.
###############################################

@CODE
if (!G("zoning"))
	exitpass();
@@CODE

@PATH _ROOT _zone

@POST
  ++X("line count");
  
  # For first line in zone.
  if (X("line count") == 1)
    {
	X("sloppy start") = N("sloppy start");
	X("prose zone") = N("prose zone");
	}

  # Grab data from the last line in zone (when you get there).
  X("sloppy end") = N("sloppy end");
  X("end punct")  = N("end punct");
  X("end dash")   = N("end dash");
  X("end comma")  = N("end comma");
  
  # Compute length of each line.
  N("nchars") = N("nalpha") + N("nnum")
              + N("npunct") + N("nwhite");

  # Get a total char count for the zone.
  X("nchars") = X("nchars") + N("nchars");
  
  # Get a total alphabetic count for the zone.
  X("walpha") = X("walpha") + N("walpha");
  X("nunknowns") = X("nunknowns") + N("nunknowns");

  # See if zone has any lowercase words.
  if (N("walpha") > N("wallcaps"))
    X("lowercase?") = 1;  # At least one lowercase word seen.

  #noop();
@RULES
_xNIL <-
	_LINE
	@@

