###############################################
# FILE: sgml100.pat
# SUBJ: Handle XML and HTML formats.
# AUTH: AM
# CREATED: 13/Jun/02 20:11:28
# MODIFIED:
###############################################

@CODE
# Only handling the case where the whole document is an
# SGML document, for simplicity.
if ((G("html") || G("xml"))
 && G("last is tag"))
  G("sgml") = 1;	# This is an SGML document.
else
  {
  G("sgml") = 0;
  exitpass();
  }
@@CODE

@NODES _ROOT

@RULES
_tag <-
	\<
	\?
	xml
	_xWILD
	\?
	\>
	@@

# NOTE: CREATES NODES LIKE _endtext and _endtitle !
@POST
  S("name") = strtolower(N("$text",3));
  group(1,5,"_end" + S("name"));
  group(1,1,"_endtag");
  N("name",1) = S("name");
@RULES
_xNIL <-
	\<
	\/
	_xALPHA
	_xWILD
	\>
	@@

# NOTE: CREATES NODES LIKE _text and _title !

@POST
  S("name") = strtolower(N("$text",2));
  group(1,4,"_" + S("name"));
  group(1,1,"_tag");
  N("name",1) = S("name");
@RULES
_xNIL <-
	\<
	_xALPHA
	_xWILD
	\>
	@@


