###############################################
# FILE: zone25.pat
# SUBJ: Studying zones.
# AUTH: AM
# CREATED: 20/Mar/02 15:54:06
# NOTE: Looking for a profile and deviations from it.
###############################################

@CODE
	exitpass();
@@CODE

@PATH _ROOT _zone

@POST
  if (!X("first"))  # At first line.
    {
	X("first") = 1; # first line seen.
	
	# Compute on first line, whether it's prose or not.
	if (!N("walpha"))	# No alphabetics.
		;
	else if (N("prose words")
	 || N("func words")
	 || N("end punct")
	 || N("end dash")
	 || N("end comma")
	 || N("sloppy end")
	 )
	  {
	  X("prose zone") = 1;
	  N("prose zone") = 1;
	  X("end punct") = N("end punct"); # Must continue prose.
	  }
#	pnrename(N(1), "_STARTZONE");
	}
  else # Not at first line.
    {
	# Compute whether current line is likely prose or not.
	if (!N("walpha"))
	   ;
	else if (N("prose words")
	 || N("func words")
	 || N("end punct")
	 || N("end dash")
	 || N("end comma")
	 || N("sloppy end")
	 )
	 {
	 N("prose zone") = 1;
	 }
	else if (X("prose zone") && !X("end punct"))
	  {
	  # Continue prose...
	  # N("prose zone") = 1;
	  }
	
	if (N("num list"))	# At numbered list line.
	  {
	  N("prose zone") = 1;
	  if (!G("in num list"))
	    {
	    G("in num list") = 1; # Flag this.
#	    pnrename(N(1), "_STARTZONE");
	    }
	  if (N("num list") == G("max num"))
	    G("in num list") = 0;	# Found last num in list.
	  X("need start") = 0;
	  }
	else if (G("in num list"))
	   {
	   N("prose zone") =1; # All in a num list is prose.
	   X("need start") = 0;
	   }
	
	else if (X("need start"))
	  {
	  pnrename(N(1),"_STARTZONE");
	  X("prose zone") = N("prose zone");
	  X("need start") = 0;
	  }
	else if (!N("walpha"))	# No alphabetics on line.
	  {
#	  group(1,1,"_zone");
	  X("need start") = 1;
	  X("prose zone") = 0;
	  }
	 
	# See if we're possibly transitioning out of a zone.
	else if (X("prose zone") != N("prose zone"))
	  {
	  # Switch zones.
	  X("prose zone") = N("prose zone");
#	  pnrename(N(1), "_STARTZONE");
	  }
	X("end punct") = N("end punct");	# Continue prose...
	}
@RULES
_xNIL <-
	_LINE
	@@
